#include<stdio.h>
#include<string.h>
#include<stdlib.h>

struct Broj
{
	int n;
	char poz;
	struct Broj *left;
	struct Broj *right;
};


void dodaj(struct Broj **koren,int broj,char c)
{
	struct Broj *temp=NULL;
	struct Broj *pom1=NULL;
	struct Broj *pom2=NULL;
	
	temp=(struct Broj *)malloc(sizeof(struct Broj));
	if(temp==NULL)
	{
		printf("Greska pri alociranju memorije!\n");
		exit(0);
	}
	temp->left=temp->right=NULL;
	temp->n=broj;
	temp->poz=c;
	
	if(*koren==NULL)
	{
		(*koren)=temp;
	}
	else
	{
		pom1=(*koren);
		
		while(pom1!=NULL)
		{
			pom2=pom1;
			
			if(temp->n<pom1->n) pom1=pom1->left;
			else pom1=pom1->right;
			
		}
			if(temp->n<pom2->n) pom2->left=temp;
			else pom2->right=temp;
	}
}

void formiraj(struct Broj **drvo)
{
		int novi,B,ukupno,troc,cifra;
		char c;
		int i;
		int prvi,drugi;
		
		printf("Unesite B: ");
		scanf("%d",&B);
		
		for(i=0; i<B; i++)
		{
			printf("Unesite trocifren broj: ");
			scanf("%d",&troc);
			printf("Unesite cifru: ");
			scanf("%d",&cifra);
			
			prvi=troc*10;
			prvi=prvi+cifra;
			drugi=cifra*1000;
		    drugi=drugi+troc;
		    
		    if(prvi>drugi)
		    {
				novi=prvi;
				c='K';
			}
			else
			{
				novi=drugi;
				c='P';
			}
			
			dodaj(drvo,novi,c);
		}
}

void stampaj(struct Broj *koren)
{
	if(koren!=NULL)
	{
		stampaj(koren->right);
		printf("%d\n",koren->n);
		stampaj(koren->left);
	}
}

int main(void)
{
	struct Broj *koren=NULL;
	
	formiraj(&koren);
	
	printf("Stablo:\n");
	
	stampaj(koren);
	
	return 0;
}
