#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct drvo
{
	int broj;
	char slovo;
	struct drvo *levo,*desno;
};

#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo));

void dodaj(struct drvo **koren, char c,int k)
{
	struct drvo *new,*pom1,*pom2;
	novi(new);
	if(!new)
	{
		printf("Greska pri alokaciji");
		exit(0);
	}
	new->broj=k;
	new->levo=new->desno=NULL;
	new->slovo=c;
	if((*koren)==NULL) *koren=new;
	else
	{
		pom1=*koren;
		while(pom1!=NULL)
		{
			pom2=pom1;
			if(pom1->broj > k) pom1=pom1->levo;
			else pom1=pom1->desno;
		}
		if(pom2->broj > k) pom2->levo=new;
		else pom2->desno=new;
	}	
}

void ispis(struct drvo *p)
{
	if(p!=NULL)
	{
		ispis(p->levo);
		printf("%d\t",p->broj);
		ispis(p->desno);
	}
}
	
void formiraj (int n,int C)
{
	struct drvo *koren=NULL;
	int broj,poc,kraj,i=0;
	char P;
	scanf("%d",&C);	//cifra koja se dodaje
	for (i=0;i<n;i++)
	{
		scanf("%d",&broj);
		poc=C*1000+broj;
		kraj=broj*10+broj;
		if (poc > kraj) 
		{
			P='P';
			dodaj(&koren,P,broj);
		}
		else 
		{
			P='K';
			dodaj(&koren,P,broj);
		}
	}
	
}

void veci(struct drvo *p,int x,int *broj)
{
	//int broj;
	if (p!=NULL)
	{
		if ((p->slovo=='P') && (p->broj >x)) (*broj)++;
		veci (p->levo,x,broj);
		veci (p->desno,x,broj);
	}
	//return broj;
}

main()
{
	struct drvo *koren=NULL;
	int n,k,x,broj=0;
	
	printf("Unesi brojeve b i C:\n");
	scanf("%d",&n);
	scanf("%d",&k);
	
	formiraj(n,k);
	ispis(koren);
	
	printf("Unesi broj X\n"); scanf("%d",&x);
	veci(koren,x,&broj);
	printf("Brojeva vecih od %d ima &d\n",x,broj);
	
}
	
