#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct _DRVO DRVO;

struct _DRVO
{
	int broj;
	char poz;
	DRVO *levo;
	DRVO *desno;
};

DRVO *element(int p, int d)
{
	DRVO *temp;
	temp = (DRVO *) malloc(sizeof(DRVO));
	temp->broj = p;
	temp->poz = d;
	temp->levo = NULL;
	temp->deson = NULL;
	
	return temp;
}

void novi(DRVO **koren, int p, int d)
{
	DRVO *poz, *temp;
	temp = element(p, d);
	
	if (koren)
	{
		poz = vrati(koren, p);
		if (poz->broj < p)
			poz->levo = temp;
		else
			poz->desno = temp;
	}
	else
		(*koren) = temp;
}
			
DRVO *form(char *file)
{
	DRVO *koren = NULL;
	FILE *f;
	int c, broj, zajedno;
	
	f = fopen(file, "r");
	
	fscanf(f, "%d", &c);
	
	int b, i, s;
	
	fscanf(f, "%d", b);
	
	for (i = 0; i < b; i++)
	{
		fscanf(f, "%d", &broj);
		s = c * 1000 + broj;
		broj = broj * 10 + c;
		
		if (broj > s)
		{
			zajedno = broj;
			s = 0;
		}
		else
		{
			zajedno = s;
			s = 1;
		}
			
		novi(koren, zajedno, s);
	}
	
	return koren;
}
