#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct stablo
{
	int broj;
	char poz;
	struct stablo *levi,*desni;
};

int koliko=0;

int srediK(char b[], char c)
{
	int i=strlen(b);
	b[i++]=c;
	
	return (atoi(b));
}

int srediP(char b[],char c)
{
	char s[10];
	int i=strlen(b);
	int j=0;
	s[j]=c;
	while(i)
	{
		s[++j]=b[i];
		i--;
	}
	
	return (atoi(s));
}

void dodaj(struct stablo **s,char b[],char c, int x)
{
	struct stablo *temp,*pom1,*pom2;
	int p,k;
	
	temp=malloc(sizeof(struct stablo));
	temp->levi=temp->desni=NULL;
	
	k=srediK(b,c);
	p=srediP(b,c);
	
	if (p>k)
	{
		temp->poz='P';
		temp->broj=p;
		if (temp->broj > x)
			koliko++;
	}
	else
	{
		temp->poz='K';
		temp->broj=k;
	}
	
	
	if(!(*s))
		*s=temp;
	else
	{
		pom1=*s;
		while(pom1)
		{
			pom2=pom1;
			if (pom1->broj > temp->broj)
				pom1=pom1->levi;
			else
				pom1=pom1->desni;
		}
		if (pom2->broj > temp->broj)
			pom2->levi=temp;
		else
			pom2->desni=temp;
	}
}

struct stablo *napravi(FILE *f)
{
	int n,x;
	char broj[10],cifra;
	struct stablo *s=NULL;
	fscanf(f,"%d",&x);
	fscanf(f,"%d",&n);
	while(n)
	{
		fscanf(f,"%s",broj);
		fgetc(f);
		fscanf(f,"%c",&cifra);
		dodaj(&s,broj,cifra,x);
		n--;
	}
	
	return s;
}

void ispis(struct stablo *s)
{
	if(s)
	{
		ispis(s->desni);
		printf("%d\t%c\n",s->broj,s->poz);
		ispis(s->levi);
	}
}


main(int argc, char *argv[])
{
	struct stablo *s=NULL;
	FILE *f=fopen(argv[1],"r");
	s=napravi(f);
	fclose(f);
	ispis(s);
	printf("\nIma ih %d.\n",koliko);
}
